Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4648)
@@ -1626,64 +1513,62 @@
 
     INTEGER(iwp) ::  bh                !< temporary vertical index of building height
+    INTEGER(iwp) ::  ch                !< temporary vertical index for canyon height
+    INTEGER(iwp) ::  hv_in             !< heavyside function to model inner tunnel surface
+    INTEGER(iwp) ::  i                 !< index variable along x
+    INTEGER(iwp) ::  index_left_bwall  !< index for left building wall
+    INTEGER(iwp) ::  index_north_bwall !< index for north building wall
+    INTEGER(iwp) ::  index_right_bwall !< index for right building wall
+    INTEGER(iwp) ::  index_south_bwall !< index for south building wall
+    INTEGER(iwp) ::  index_left_cwall  !< index for left canyon wall
+    INTEGER(iwp) ::  index_north_cwall !< index for north canyon wall
+    INTEGER(iwp) ::  index_right_cwall !< index for right canyon wall
+    INTEGER(iwp) ::  index_south_cwall !< index for south canyon wall
+    INTEGER(iwp) ::  j                 !< index variable along y
+    INTEGER(iwp) ::  k                 !< index variable along z
     INTEGER(iwp) ::  ngp_bx            !< grid point number of building size along x
     INTEGER(iwp) ::  ngp_by            !< grid point number of building size along y
-    INTEGER(iwp) ::  index_left_bwall  !< index for left building wall
-    INTEGER(iwp) ::  index_right_bwall !< index for right building wall
-    INTEGER(iwp) ::  index_north_bwall !< index for north building wall
-    INTEGER(iwp) ::  index_south_bwall !< index for south building wall
-    INTEGER(iwp) ::  ch                !< temporary vertical index for canyon height
     INTEGER(iwp) ::  ngp_cx            !< grid point number of canyon size along x
     INTEGER(iwp) ::  ngp_cy            !< grid point number of canyon size along y
-    INTEGER(iwp) ::  index_left_cwall  !< index for left canyon wall
-    INTEGER(iwp) ::  index_right_cwall !< index for right canyon wall
-    INTEGER(iwp) ::  index_north_cwall !< index for north canyon wall
-    INTEGER(iwp) ::  index_south_cwall !< index for south canyon wall
-    INTEGER(iwp) ::  i                 !< index variable along x
-    INTEGER(iwp) ::  j                 !< index variable along y
-    INTEGER(iwp) ::  k                 !< index variable along z
-    INTEGER(iwp) ::  hv_in             !< heavyside function to model inner tunnel surface 
-    INTEGER(iwp) ::  hv_out            !< heavyside function to model outer tunnel surface 
-    INTEGER(iwp) ::  txe_out           !< end position of outer tunnel wall in x
-    INTEGER(iwp) ::  txs_out           !< start position of outer tunnel wall in x
-    INTEGER(iwp) ::  tye_out           !< end position of outer tunnel wall in y
-    INTEGER(iwp) ::  tys_out           !< start position of outer tunnel wall in y
-    INTEGER(iwp) ::  txe_in            !< end position of inner tunnel wall in x
-    INTEGER(iwp) ::  txs_in            !< start position of inner tunnel wall in x
-    INTEGER(iwp) ::  tye_in            !< end position of inner tunnel wall in y
-    INTEGER(iwp) ::  tys_in            !< start position of inner tunnel wall in y
+    INTEGER(iwp) ::  hv_out            !< heavyside function to model outer tunnel surface
     INTEGER(iwp) ::  td                !< tunnel wall depth
     INTEGER(iwp) ::  th                !< height of outer tunnel wall
+    INTEGER(iwp) ::  txe_in            !< end position of inner tunnel wall in x
+    INTEGER(iwp) ::  txe_out           !< end position of outer tunnel wall in x
+    INTEGER(iwp) ::  txs_in            !< start position of inner tunnel wall in x
+    INTEGER(iwp) ::  txs_out           !< start position of outer tunnel wall in x
+    INTEGER(iwp) ::  tye_in            !< end position of inner tunnel wall in y
+    INTEGER(iwp) ::  tye_out           !< end position of outer tunnel wall in y
+    INTEGER(iwp) ::  tys_in            !< start position of inner tunnel wall in y
+    INTEGER(iwp) ::  tys_out           !< start position of outer tunnel wall in y
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_local         !< index for topography top at cell-center
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo !< input array for 3D topography and dummy array for setting "outer"-flags
-!
-!-- Check for correct setting of the namelist parameter topography. If 
-!-- topography information is read from file but topography = 'flat', 
-!-- initialization does not work properly.
-    IF ( ( buildings_f%from_file  .OR.  terrain_height_f%from_file )  .AND.    &
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo !< input array for 3D topography and dummy array for setting
+                                                                    !< "outer"-flags
+!
+!-- Check for correct setting of the namelist parameter topography. If topography information is
+!-- read from file but topography = 'flat', initialization does not work properly.
+    IF ( ( buildings_f%from_file  .OR.  terrain_height_f%from_file )  .AND.                        &
            TRIM( topography ) /= 'read_from_file' )  THEN
-       message_string =  'If topography information is provided (via ' //      &
-                         'Netcdf or ASCII input) topography = '        //      &
+       message_string =  'If topography information is provided (via ' //                          &
+                         'Netcdf or ASCII input) topography = '        //                          &
                          '"read_from_file" is required.'
-       CALL message( 'init_grid', 'PA0437', 1, 2, 0, 6, 0 )      
+       CALL message( 'init_grid', 'PA0437', 1, 2, 0, 6, 0 )
     ENDIF
 !
 !-- Set outer and inner index arrays for non-flat topography.
-!-- Here consistency checks concerning domain size and periodicity are
-!-- necessary.
-!-- Within this SELECT CASE structure only nzb_local is initialized
-!-- individually depending on the chosen topography type, all other index 
-!-- arrays are initialized further below.
+!-- Here consistency checks concerning domain size and periodicity are necessary.
+!-- Within this SELECT CASE structure only nzb_local is initialized individually depending on the
+!-- chosen topography type, all other index arrays are initialized further below.
     SELECT CASE ( TRIM( topography ) )
 
        CASE ( 'flat' )
-!   
+!
 !--       Initialilize 3D topography array, used later for initializing flags
           topo(nzb+1:nzt+1,:,:) = IBSET( topo(nzb+1:nzt+1,:,:), 0 )
-          
+
        CASE ( 'closed_channel' )
-!   
+!
 !--       Initialilize 3D topography array, used later for initializing flags
-          topo(nzb+1:nzt,:,:) = IBSET( topo(nzb+1:nzt,:,:), 0 ) 
+          topo(nzb+1:nzt,:,:) = IBSET( topo(nzb+1:nzt,:,:), 0 )
 
        CASE ( 'single_building' )
@@ -1694,6 +1579,5 @@
           ngp_by = NINT( building_length_y / dy )
           bh  = MINLOC( ABS( zw - building_height ), 1 ) - 1
-          IF ( ABS( zw(bh)   - building_height ) == &
-               ABS( zw(bh+1) - building_height )    )  bh = bh + 1
+          IF ( ABS( zw(bh) - building_height ) ==  ABS( zw(bh+1) - building_height ) )  bh = bh + 1
           IF ( building_wall_left == 9999999.9_wp )  THEN
              building_wall_left = ( nx + 1 - ngp_bx ) / 2 * dx
@@ -1710,13 +1594,13 @@
 !
 !--       Building size has to meet some requirements
-          IF ( ( index_left_bwall < 1 ) .OR. ( index_right_bwall > nx-1 ) .OR. &
-               ( index_right_bwall < index_left_bwall+3 ) .OR.                 &
-               ( index_south_bwall < 1 ) .OR. ( index_north_bwall > ny-1 ) .OR.&
+          IF ( ( index_left_bwall  < 1 )  .OR.  ( index_right_bwall > nx-1 )  .OR.                 &
+               ( index_right_bwall < index_left_bwall+3 )  .OR.                                    &
+               ( index_south_bwall < 1 )  .OR.  ( index_north_bwall > ny-1 )  .OR.                 &
                ( index_north_bwall < index_south_bwall+3 ) )  THEN
-             WRITE( message_string, * ) 'inconsistent building parameters:',   &
-                                      '&index_left_bwall=', index_left_bwall,  &
-                                      'index_right_bwall=', index_right_bwall, &
-                                      'index_south_bwall=', index_south_bwall, &
-                                      'index_north_bwall=', index_north_bwall, &
+             WRITE( message_string, * ) 'inconsistent building parameters:',                       &
+                                      '&index_left_bwall=', index_left_bwall,                      &
+                                      'index_right_bwall=', index_right_bwall,                     &
+                                      'index_south_bwall=', index_south_bwall,                     &
+                                      'index_north_bwall=', index_north_bwall,                     &
                                       'nx=', nx, 'ny=', ny
              CALL message( 'init_grid', 'PA0203', 1, 2, 0, 6, 0 )
@@ -1726,8 +1610,8 @@
           nzb_local = 0
 !
-!--       Define the building. 
-          IF ( index_left_bwall <= nxr  .AND.  index_right_bwall >= nxl  .AND. &
-               index_south_bwall <= nyn  .AND.  index_north_bwall >= nys )     & 
-             nzb_local(MAX(nys,index_south_bwall):MIN(nyn,index_north_bwall),  &
+!--       Define the building.
+          IF ( index_left_bwall <= nxr  .AND.  index_right_bwall >= nxl  .AND.                     &
+               index_south_bwall <= nyn  .AND.  index_north_bwall >= nys )                         &
+             nzb_local(MAX(nys,index_south_bwall):MIN(nyn,index_north_bwall),                      &
                        MAX(nxl,index_left_bwall):MIN(nxr,index_right_bwall)) = bh
 !
@@ -1735,23 +1619,22 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                topo(nzb_local(j,i)+1:nzt+1,j,i) =                             &
-                                 IBSET( topo(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
+                topo(nzb_local(j,i)+1:nzt+1,j,i) = IBSET( topo(nzb_local(j,i)+1:nzt+1,j,i), 0 )
              ENDDO
           ENDDO
-        
+
           DEALLOCATE( nzb_local )
 
           CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
 !
-!--       Set boundary conditions also for flags. Can be interpreted as Neumann
-!--       boundary conditions for topography. 
+!--       Set boundary conditions also for flags. Can be interpreted as Neumannb oundary conditions
+!--       for topography.
           IF ( .NOT. bc_ns_cyc )  THEN
              IF ( nys == 0  )  THEN
-                DO  i = 1, nbgp     
+                DO  i = 1, nbgp
                    topo(:,nys-i,:)   = topo(:,nys,:)
                 ENDDO
              ENDIF
              IF ( nyn == ny )  THEN
-                DO  i = 1, nbgp  
+                DO  i = 1, nbgp
                    topo(:,nyn+i,:) = topo(:,nyn,:)
                 ENDDO
@@ -1760,13 +1643,13 @@
           IF ( .NOT. bc_lr_cyc )  THEN
              IF ( nxl == 0  )  THEN
-                DO  i = 1, nbgp   
+                DO  i = 1, nbgp
                    topo(:,:,nxl-i)   = topo(:,:,nxl)
                 ENDDO
              ENDIF
-             IF ( nxr == nx )  THEN 
-                DO  i = 1, nbgp   
-                   topo(:,:,nxr+i) = topo(:,:,nxr)     
+             IF ( nxr == nx )  THEN
+                DO  i = 1, nbgp
+                   topo(:,:,nxr+i) = topo(:,:,nxr)
                 ENDDO
-             ENDIF      
+             ENDIF
           ENDIF
 
@@ -1793,43 +1676,39 @@
              index_south_cwall = NINT( canyon_wall_south / dy )
              index_north_cwall = index_south_cwall + ngp_cy
-      
+
           ELSE
-             
+
              message_string = 'no street canyon width given'
              CALL message( 'init_grid', 'PA0204', 1, 2, 0, 6, 0 )
-  
+
           ENDIF
 
           ch  = MINLOC( ABS( zw - canyon_height ), 1 ) - 1
-          IF ( ABS( zw(ch)   - canyon_height ) == &
-               ABS( zw(ch+1) - canyon_height )    )  ch = ch + 1
+          IF ( ABS( zw(ch) - canyon_height ) == ABS( zw(ch+1) - canyon_height ) )  ch = ch + 1
           dp_level_ind_b = ch
 !
 !--       Street canyon size has to meet some requirements
           IF ( canyon_width_x /= 9999999.9_wp )  THEN
-             IF ( ( index_left_cwall< 1 ) .OR. ( index_right_cwall> nx-1 ) .OR.&
+             IF ( ( index_left_cwall< 1 )  .OR.  ( index_right_cwall> nx-1 )  .OR.                 &
                   ( ngp_cx < 3 ) )  THEN
-                WRITE( message_string, * ) 'inconsistent canyon parameters:',  &
-                                           '&index_left_cwall=', index_left_cwall, &
-                                           ' index_right_cwall=', index_right_cwall, &
-                                           ' ngp_cx=', ngp_cx,                 &
-                                           ' ch=', ch, ' nx=', nx, ' ny=', ny
-                CALL message( 'init_grid', 'PA0205', 1, 2, 0, 6, 0 ) 
+                WRITE( message_string, * ) 'inconsistent canyon parameters:',                      &
+                                           '&index_left_cwall=', index_left_cwall,                 &
+                                           ' index_right_cwall=', index_right_cwall,               &
+                                           ' ngp_cx=', ngp_cx, ' ch=', ch, ' nx=', nx, ' ny=', ny
+                CALL message( 'init_grid', 'PA0205', 1, 2, 0, 6, 0 )
              ENDIF
           ELSEIF ( canyon_width_y /= 9999999.9_wp )  THEN
-             IF ( ( index_south_cwall < 1 ) .OR.                               &
-                  ( index_north_cwall > ny-1 ) .OR. ( ngp_cy < 3 ) )  THEN
-                WRITE( message_string, * ) 'inconsistent canyon parameters:',  &
-                                           '&index_south_cwall=', index_south_cwall, & 
-                                           ' index_north_cwall=', index_north_cwall, &
-                                           ' ngp_cy=', ngp_cy,                 &
-                                           ' ch=', ch, ' nx=', nx, ' ny=', ny
-                CALL message( 'init_grid', 'PA0206', 1, 2, 0, 6, 0 ) 
-             ENDIF
-          ENDIF
-          IF ( canyon_width_x /= 9999999.9_wp .AND.                            &                 
-               canyon_width_y /= 9999999.9_wp )  THEN
-             message_string = 'inconsistent canyon parameters:' //             &   
-                              '&street canyon can only be oriented' //         &
+             IF ( ( index_south_cwall < 1 )  .OR.                                                  &
+                  ( index_north_cwall > ny-1 )  .OR.  ( ngp_cy < 3 ) )  THEN
+                WRITE( message_string, * ) 'inconsistent canyon parameters:',                      &
+                                           '&index_south_cwall=', index_south_cwall,               &
+                                           ' index_north_cwall=', index_north_cwall,               &
+                                           ' ngp_cy=', ngp_cy, ' ch=', ch, ' nx=', nx, ' ny=', ny
+                CALL message( 'init_grid', 'PA0206', 1, 2, 0, 6, 0 )
+             ENDIF
+          ENDIF
+          IF ( canyon_width_x /= 9999999.9_wp  .AND.  canyon_width_y /= 9999999.9_wp )  THEN
+             message_string = 'inconsistent canyon parameters:' //                                 &
+                              '&street canyon can only be oriented' //                             &
                               ' either in x- or in y-direction'
              CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
@@ -1839,8 +1718,8 @@
           nzb_local = ch
           IF ( canyon_width_x /= 9999999.9_wp )  THEN
-             IF ( index_left_cwall<= nxr  .AND.  index_right_cwall>= nxl )     &
+             IF ( index_left_cwall<= nxr  .AND.  index_right_cwall>= nxl )                         &
                 nzb_local(:,MAX(nxl,index_left_cwall+1):MIN(nxr,index_right_cwall-1)) = 0
           ELSEIF ( canyon_width_y /= 9999999.9_wp )  THEN
-             IF ( index_south_cwall <= nyn  .AND.  index_north_cwall >= nys )  &          
+             IF ( index_south_cwall <= nyn  .AND.  index_north_cwall >= nys )                      &
                 nzb_local(MAX(nys,index_south_cwall+1):MIN(nyn,index_north_cwall-1),:) = 0
           ENDIF
@@ -1849,6 +1728,5 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                topo(nzb_local(j,i)+1:nzt+1,j,i) =                             &
-                                 IBSET( topo(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
+                topo(nzb_local(j,i)+1:nzt+1,j,i) = IBSET( topo(nzb_local(j,i)+1:nzt+1,j,i), 0 )
              ENDDO
           ENDDO
@@ -1857,14 +1735,14 @@
           CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
 !
-!--       Set boundary conditions also for flags. Can be interpreted as Neumann
-!--       boundary conditions for topography. 
+!--       Set boundary conditions also for flags. Can be interpreted as Neumann boundary conditions
+!--       for topography.
           IF ( .NOT. bc_ns_cyc )  THEN
              IF ( nys == 0  )  THEN
-                DO  i = 1, nbgp     
-                   topo(:,nys-i,:)   = topo(:,nys,:)
+                DO  i = 1, nbgp
+                   topo(:,nys-i,:) = topo(:,nys,:)
                 ENDDO
              ENDIF
              IF ( nyn == ny )  THEN
-                DO  i = 1, nbgp  
+                DO  i = 1, nbgp
                    topo(:,nyn+i,:) = topo(:,nyn,:)
                 ENDDO
@@ -1873,13 +1751,13 @@
           IF ( .NOT. bc_lr_cyc )  THEN
              IF ( nxl == 0  )  THEN
-                DO  i = 1, nbgp   
-                   topo(:,:,nxl-i)   = topo(:,:,nxl)
+                DO  i = 1, nbgp
+                   topo(:,:,nxl-i) = topo(:,:,nxl)
                 ENDDO
              ENDIF
-             IF ( nxr == nx )  THEN 
-                DO  i = 1, nbgp   
-                   topo(:,:,nxr+i) = topo(:,:,nxr)     
+             IF ( nxr == nx )  THEN
+                DO  i = 1, nbgp
+                   topo(:,:,nxr+i) = topo(:,:,nxr)
                 ENDDO
-             ENDIF      
+             ENDIF
           ENDIF
 
@@ -1895,5 +1773,5 @@
 !
 !--       Tunnel-wall depth
-          IF ( tunnel_wall_depth == 9999999.9_wp )  THEN  
+          IF ( tunnel_wall_depth == 9999999.9_wp )  THEN
              td = MAX ( dx, dy, dz(1) )
           ELSE
@@ -1902,13 +1780,11 @@
 !
 !--       Check for tunnel width
-          IF ( tunnel_width_x == 9999999.9_wp  .AND.                           &
-               tunnel_width_y == 9999999.9_wp  )  THEN
+          IF ( tunnel_width_x == 9999999.9_wp  .AND.  tunnel_width_y == 9999999.9_wp  )  THEN
              message_string = 'No tunnel width is given. '
              CALL message( 'init_grid', 'PA0280', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( tunnel_width_x /= 9999999.9_wp  .AND.                           &
-               tunnel_width_y /= 9999999.9_wp  )  THEN
-             message_string = 'Inconsistent tunnel parameters:' //             &   
-                              'tunnel can only be oriented' //                 &
+          IF ( tunnel_width_x /= 9999999.9_wp  .AND.  tunnel_width_y /= 9999999.9_wp  )  THEN
+             message_string = 'Inconsistent tunnel parameters:' //                                 &
+                              'tunnel can only be oriented' //                                     &
                               'either in x- or in y-direction.'
              CALL message( 'init_grid', 'PA0281', 1, 2, 0, 6, 0 )
@@ -1916,10 +1792,10 @@
 !
 !--       Check for too small tunnel width in x- and y-direction
-          IF ( tunnel_width_x /= 9999999.9_wp  .AND.                           &   
+          IF ( tunnel_width_x /= 9999999.9_wp  .AND.                                               &
                tunnel_width_x - 2.0_wp * td <= 2.0_wp * dx )  THEN
              message_string = 'tunnel_width_x too small'
              CALL message( 'init_grid', 'PA0175', 1, 2, 0, 6, 0 )
           ENDIF
-          IF ( tunnel_width_y /= 9999999.9_wp  .AND.                           &
+          IF ( tunnel_width_y /= 9999999.9_wp  .AND.                                               &
                tunnel_width_y - 2.0_wp * td <= 2.0_wp * dy )  THEN
              message_string = 'tunnel_width_y too small'
@@ -1927,5 +1803,5 @@
           ENDIF
 !
-!--       Check for too large tunnel width. 
+!--       Check for too large tunnel width.
 !--       Tunnel axis along y.
           IF ( tunnel_width_x /= 9999999.9_wp )  THEN
@@ -1937,8 +1813,6 @@
              txs_out = INT( ( nx + 1 ) * 0.5_wp * dx - tunnel_width_x * 0.5_wp )
              txe_out = INT( ( nx + 1 ) * 0.5_wp * dx + tunnel_width_x * 0.5_wp )
-             txs_in  = INT( ( nx + 1 ) * 0.5_wp * dx -                         &
-                                      ( tunnel_width_x * 0.5_wp - td ) )
-             txe_in  = INT( ( nx + 1 ) * 0.5_wp * dx +                         &
-                                   ( tunnel_width_x * 0.5_wp - td ) )
+             txs_in  = INT( ( nx + 1 ) * 0.5_wp * dx - ( tunnel_width_x * 0.5_wp - td ) )
+             txe_in  = INT( ( nx + 1 ) * 0.5_wp * dx + ( tunnel_width_x * 0.5_wp - td ) )
 
              tys_out = INT( ( ny + 1 ) * 0.5_wp * dy - tunnel_length * 0.5_wp )
@@ -1962,8 +1836,6 @@
              tys_out = INT( ( ny + 1 ) * 0.5_wp * dy - tunnel_width_y * 0.5_wp )
              tye_out = INT( ( ny + 1 ) * 0.5_wp * dy + tunnel_width_y * 0.5_wp )
-             tys_in  = INT( ( ny + 1 ) * 0.5_wp * dy -                         &
-                                        ( tunnel_width_y * 0.5_wp - td ) )
-             tye_in  = INT( ( ny + 1 ) * 0.5_wp * dy +                         &
-                                     ( tunnel_width_y * 0.5_wp - td ) )
+             tys_in  = INT( ( ny + 1 ) * 0.5_wp * dy - ( tunnel_width_y * 0.5_wp - td ) )
+             tye_in  = INT( ( ny + 1 ) * 0.5_wp * dy + ( tunnel_width_y * 0.5_wp - td ) )
           ENDIF
 
@@ -1973,20 +1845,16 @@
 !
 !--             Use heaviside function to model outer tunnel surface
-                hv_out = th * 0.5_wp *                                         &
-                              ( ( SIGN( 1.0_wp, i * dx - txs_out ) + 1.0_wp )  &
-                              - ( SIGN( 1.0_wp, i * dx - txe_out ) + 1.0_wp ) )
-
-                hv_out = hv_out * 0.5_wp *                                     &
-                            ( ( SIGN( 1.0_wp, j * dy - tys_out ) + 1.0_wp )    &
-                            - ( SIGN( 1.0_wp, j * dy - tye_out ) + 1.0_wp ) )
-!    
+                hv_out = th * 0.5_wp * ( ( SIGN( 1.0_wp, i * dx - txs_out ) + 1.0_wp )             &
+                                       - ( SIGN( 1.0_wp, i * dx - txe_out ) + 1.0_wp ) )
+
+                hv_out = hv_out * 0.5_wp * ( ( SIGN( 1.0_wp, j * dy - tys_out ) + 1.0_wp )         &
+                                           - ( SIGN( 1.0_wp, j * dy - tye_out ) + 1.0_wp ) )
+!
 !--             Use heaviside function to model inner tunnel surface
-                hv_in  = ( th - td ) * 0.5_wp *                                &
-                                ( ( SIGN( 1.0_wp, i * dx - txs_in ) + 1.0_wp ) &
-                                - ( SIGN( 1.0_wp, i * dx - txe_in ) + 1.0_wp ) )
-
-                hv_in = hv_in * 0.5_wp *                                       &
-                                ( ( SIGN( 1.0_wp, j * dy - tys_in ) + 1.0_wp ) &
-                                - ( SIGN( 1.0_wp, j * dy - tye_in ) + 1.0_wp ) )
+                hv_in  = ( th - td ) * 0.5_wp * ( ( SIGN( 1.0_wp, i * dx - txs_in ) + 1.0_wp )     &
+                                                - ( SIGN( 1.0_wp, i * dx - txe_in ) + 1.0_wp ) )
+
+                hv_in = hv_in * 0.5_wp * ( ( SIGN( 1.0_wp, j * dy - tys_in ) + 1.0_wp )            &
+                                         - ( SIGN( 1.0_wp, j * dy - tye_in ) + 1.0_wp ) )
 !
 !--             Set flags at x-y-positions without any tunnel surface
@@ -2009,9 +1877,9 @@
 !--                   Lateral tunnel walls
                       IF ( hv_out - hv_in == td )  THEN
-                         IF ( zw(k) <= hv_in )  THEN 
+                         IF ( zw(k) <= hv_in )  THEN
                             topo(k,j,i) = IBSET( topo(k,j,i), 0 )
-                         ELSEIF ( zw(k) > hv_in  .AND.  zw(k) <= hv_out )  THEN 
+                         ELSEIF ( zw(k) > hv_in  .AND.  zw(k) <= hv_out )  THEN
                             topo(k,j,i) = IBCLR( topo(k,j,i), 0 )
-                         ELSEIF ( zw(k) > hv_out )  THEN 
+                         ELSEIF ( zw(k) > hv_out )  THEN
                             topo(k,j,i) = IBSET( topo(k,j,i), 0 )
                          ENDIF
@@ -2024,14 +1892,14 @@
           CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
 !
-!--       Set boundary conditions also for flags. Can be interpreted as Neumann
-!--       boundary conditions for topography. 
+!--       Set boundary conditions also for flags. Can be interpreted as Neumann boundary conditions
+!--       for topography.
           IF ( .NOT. bc_ns_cyc )  THEN
              IF ( nys == 0  )  THEN
-                DO  i = 1, nbgp     
-                   topo(:,nys-i,:)   = topo(:,nys,:)
+                DO  i = 1, nbgp
+                   topo(:,nys-i,:) = topo(:,nys,:)
                 ENDDO
              ENDIF
              IF ( nyn == ny )  THEN
-                DO  i = 1, nbgp  
+                DO  i = 1, nbgp
                    topo(:,nyn+i,:) = topo(:,nyn,:)
                 ENDDO
@@ -2040,23 +1908,22 @@
           IF ( .NOT. bc_lr_cyc )  THEN
              IF ( nxl == 0  )  THEN
-                DO  i = 1, nbgp   
-                   topo(:,:,nxl-i)   = topo(:,:,nxl)
+                DO  i = 1, nbgp
+                   topo(:,:,nxl-i) = topo(:,:,nxl)
                 ENDDO
              ENDIF
-             IF ( nxr == nx )  THEN 
-                DO  i = 1, nbgp   
-                   topo(:,:,nxr+i) = topo(:,:,nxr)     
+             IF ( nxr == nx )  THEN
+                DO  i = 1, nbgp
+                   topo(:,:,nxr+i) = topo(:,:,nxr)
                 ENDDO
-             ENDIF      
+             ENDIF
           ENDIF
 
        CASE ( 'read_from_file' )
 !
-!--       Note, topography information have been already read.  
-!--       If required, further process topography, i.e. reference buildings on
-!--       top of orography and set temporary 3D topography array, which is 
-!--       used later to set grid flags. Calling of this rouinte is also 
-!--       required in case of ASCII input, even though no distinction between 
-!--       terrain- and building height is made in this case.  
+!--       Note, topography information have been already read.
+!--       If required, further process topography, i.e. reference buildings on top of orography and
+!--       set temporary 3D topography array, which is used later to set grid flags. Calling of this
+!--       rouinte is also required in case of ASCII input, even though no distinction between
+!--       terrain- and building height is made in this case.
           CALL process_topography( topo )
 !
@@ -2064,6 +1931,5 @@
           CALL filter_topography( topo )
 !
-!--       Exchange ghost-points, as well as add cyclic or Neumann boundary 
-!--       conditions.
+!--       Exchange ghost-points, as well as add cyclic or Neumann boundary conditions.
           CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
 !
@@ -2071,10 +1937,10 @@
           IF ( .NOT. bc_ns_cyc )  THEN
              IF ( nys == 0  )  THEN
-                DO  i = 1, nbgp         
+                DO  i = 1, nbgp
                    topo(:,nys-i,:) = topo(:,nys,:)
                 ENDDO
              ENDIF
              IF ( nyn == ny )  THEN
-                DO  i = 1, nbgp         
+                DO  i = 1, nbgp
                    topo(:,nyn+i,:) = topo(:,nyn,:)
                 ENDDO
@@ -2084,10 +1950,10 @@
           IF ( .NOT. bc_lr_cyc )  THEN
              IF ( nxl == 0  )  THEN
-                DO  i = 1, nbgp 
+                DO  i = 1, nbgp
                    topo(:,:,nxl-i) = topo(:,:,nxl)
                 ENDDO
              ENDIF
              IF ( nxr == nx )  THEN
-                DO  i = 1, nbgp 
+                DO  i = 1, nbgp
                    topo(:,:,nxr+i) = topo(:,:,nxr)
                 ENDDO
@@ -2097,9 +1963,8 @@
 
        CASE DEFAULT
-!   
-!--       The DEFAULT case is reached either if the parameter topography
-!--       contains a wrong character string or if the user has defined a special
-!--       case in the user interface. There, the subroutine user_init_grid 
-!--       checks which of these two conditions applies.
+!
+!--       The DEFAULT case is reached either if the parameter topography contains a wrong character
+!--       string or if the user has defined a special case in the user interface. There, the
+!--       subroutine user_init_grid checks which of these two conditions applies.
           CALL user_init_grid( topo )
           CALL filter_topography( topo )
